<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 7.8.4: Command Execution</title>
<link href="sx10j.html" rev=precedes>
<link href="sx10l.html" rel=precedes>
<link href="sx10.html" rev=subdocument>
</head>
<body>
<H2>section 7.8.4: Command Execution</H2>

page 167
<p>The only thing to add to this brief description of 
<TT>system</TT> concerns the disposition of the executed 
command's output.
(Similar arguments apply to its input.)
The output generally goes wherever the calling program's output goes,
though if the calling program has done anything with <TT>stdout</TT>
(such as closing it, or redirecting it within the program with 
<TT>freopen</TT>),
those changes will probably <em>not</em> affect the output of 
<TT>system</TT>.
One way to achieve redirection of the command executed by <TT>system</TT>,
if the operating system permits it, is to use redirection 
notation <em>within</em> the command line passed to 
<TT>system</TT>:
<pre>	system("date &gt; outfile");
</pre>Note also that the exit status returned by the program
(and hence perhaps by <TT>system</TT>)
does not necessarily have anything to do
with anything printed by the program.
One way to capture the output printed by the program
is to use redirection, as above,
then open and read the output file.
</p><hr>
<p>
Read sequentially:
<a href="sx10j.html" rev=precedes>prev</a>
<a href="sx10l.html" rel=precedes>next</a>
<a href="sx10.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
